import 'package:flutter/material.dart';
import 'dart:math';

import 'package:taboola_sdk/taboola.dart';
import 'package:taboola_sdk_example/DefaultProperties.dart' as PublisherProperties;

class TaboolaStandardTest extends StatelessWidget {
  TaboolaStandardBuilder _taboolaStandardBuilder;

  TaboolaStandardTest() {
    Taboola.init(PublisherInfo(PublisherProperties.publisher));
    _taboolaStandardBuilder = Taboola.getTaboolaStandardBuilder(PublisherProperties.pageUrl, PublisherProperties.pageType);
  }

  @override
  Widget build(BuildContext context) {
    Random _random = new Random();

    return Center(
        child: Column(

          mainAxisAlignment: MainAxisAlignment.start,
          mainAxisSize: MainAxisSize.max,
          crossAxisAlignment: CrossAxisAlignment.stretch,

          children: [
            _buildSeparator(Color.fromARGB(255, _random.nextInt(255), _random.nextInt(255), _random.nextInt(255))),
            _buildSeparator(Color.fromARGB(255, _random.nextInt(255), _random.nextInt(255), _random.nextInt(255))),
            _buildSeparator(Color.fromARGB(255, 55, 55, 55)),
            _taboolaStandardBuilder.build(PublisherProperties.placementMiddle, PublisherProperties.mode),
            _buildSeparator(Color.fromARGB(255, _random.nextInt(255), _random.nextInt(255), _random.nextInt(255))),
            _buildSeparator(Color.fromARGB(255, _random.nextInt(255), _random.nextInt(255), _random.nextInt(255))),
            _buildSeparator(Color.fromARGB(255, 30, 30, 30)),
          ],
        )
    );
  }

  Widget _buildSeparator(Color color) {
    return Container(
      height: 16,
      width: 300,
      alignment: Alignment.topRight,
      margin: const EdgeInsets.only(top: 4.0, bottom: 4.0),
      color: color,
    );
  }
}