import 'package:taboola_sdk/publisher_info.dart';
import 'package:taboola_sdk/standard/taboola_standard.dart';

class TaboolaStandardBuilder {
  PublisherInfo _publisherInfo;
  String _pageUrl;
  String _pageType;
  String _targetType = "mix";

  /// Optional params
  String _pageId = "auto"; //default value

  /// Constructor
  TaboolaStandardBuilder(this._publisherInfo, this._pageUrl, this._pageType);

  /// Builder
  TaboolaStandard build(String placement, String mode){ //TODO: TaboolaStandardListener taboolaStandardListener
    if (_publisherInfo == null) {
      throw ('PublisherInfo is null, did you call Taboola init?');
    }

    return new TaboolaStandard(_publisherInfo.publisherId, mode, placement, _pageType, _pageUrl, _pageId, _targetType);
  }

}