import 'dart:async';

import 'package:flutter/foundation.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'package:taboola_sdk/standard/web_view_manager.dart';

typedef GetWebViewHeight = void Function(double);

class TaboolaWebView extends StatefulWidget {
  TaboolaWebView(this._publisher, this._placement, this._mode, this._pageType, this._pageUrl, this._pageId, this._targetType, this._webViewManager);

  WebViewManager _webViewManager;
  String _publisher, _placement, _mode, _pageType, _pageUrl, _pageId, _targetType;

//  final GetWebViewHeight callback;

  @override
  State<StatefulWidget> createState() => TaboolaWebViewState(_publisher, _placement, _mode, _pageType, _pageUrl, _pageId, _targetType, _webViewManager);
}

class TaboolaWebViewState extends State<TaboolaWebView> {
  WebViewController _controller;

  WebViewManager _webViewManager;
  String _publisher, _placement, _mode, _pageType, _pageUrl, _pageId, _targetType;

  TaboolaWebViewState(this._publisher, this._placement, this._mode,this. _pageType, this._pageUrl, this._pageId, this._targetType, this._webViewManager);

  String encodeParam(String param) {
    if (param != null) {
      return Uri.encodeFull(param);
    }
    return "";
  }

  @override
  Widget build(BuildContext context) {
    String initialUrl =
        "https://cdn.taboola.com/shared/templateJS.html?allow_mock=1"
        "&publisher=${encodeParam(_publisher)}"
        "&mode=${encodeParam(_mode)}"
        "&pageType=${encodeParam(_pageType)}"
        "&placement=${encodeParam(_placement)}"
        "&targetType=${encodeParam(_targetType)}"
        "&pageId=${encodeParam(_pageId)}"
        "&pageUrl=${encodeParam(_pageUrl)}"
        "&DIV_ID=taboola2"
        "&viewID=1535012408";

    debugPrint(initialUrl);
    return WebView(
      initialUrl: initialUrl,
      javascriptMode: JavascriptMode.unrestricted,
      onWebViewCreated: (WebViewController webViewController) {
        _controller = webViewController;
      },
      javascriptChannels: Set.from([_webViewManager.javascriptChannel()]),
      onPageFinished: (some) async {
        _webViewManager.controller = _controller;
        double height = double.parse(await _controller.evaluateJavascript("document.documentElement.scrollHeight;"));
//        callback(height);
//        setState(() {

//        });
      },

//          (some) async {
//        var url = await _controller.future.data.currentUrl();
//        double height = double.parse(await _listController[0]
//            .evaluateJavascript(
//            "document.documentElement.scrollHeight;"));
//        setState(() {
//          debugPrint("$height");
//        });
//      },
      gestureRecognizers: Set()
        ..add(Factory<VerticalDragGestureRecognizer>(() => VerticalDragGestureRecognizer())),
    );
  }
}
